Index: trunk/source/geometry/navigation/include/G4TransportationManager.icc
===================================================================
--- trunk/source/geometry/navigation/include/G4TransportationManager.icc	(revision 1337)
+++ trunk/source/geometry/navigation/include/G4TransportationManager.icc	(revision 1347)
@@ -26,5 +26,5 @@
 //
 // $Id: G4TransportationManager.icc,v 1.10 2007/04/20 15:28:37 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 // ------------------------------------------------------------
 //  GEANT 4  inlined function members implementation
Index: trunk/source/geometry/navigation/include/G4VIntersectionLocator.hh
===================================================================
--- trunk/source/geometry/navigation/include/G4VIntersectionLocator.hh	(revision 1337)
+++ trunk/source/geometry/navigation/include/G4VIntersectionLocator.hh	(revision 1347)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VIntersectionLocator.hh,v 1.6 2009/11/30 11:39:15 japost Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 //
Index: trunk/source/geometry/navigation/include/G4VIntersectionLocator.icc
===================================================================
--- trunk/source/geometry/navigation/include/G4VIntersectionLocator.icc	(revision 1337)
+++ trunk/source/geometry/navigation/include/G4VIntersectionLocator.icc	(revision 1347)
@@ -26,5 +26,5 @@
 //
 // $Id: G4VIntersectionLocator.icc,v 1.3 2008/11/14 18:26:35 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 //
Index: trunk/source/geometry/navigation/include/G4VoxelNavigation.hh
===================================================================
--- trunk/source/geometry/navigation/include/G4VoxelNavigation.hh	(revision 1337)
+++ trunk/source/geometry/navigation/include/G4VoxelNavigation.hh	(revision 1347)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4VoxelNavigation.hh,v 1.5 2007/05/11 13:43:59 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// $Id: G4VoxelNavigation.hh,v 1.8 2010/11/04 12:13:30 japost Exp $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // 
@@ -44,4 +44,5 @@
 #include "geomdefs.hh"
 #include "G4NavigationHistory.hh"
+#include "G4NavigationLogger.hh"
 #include "G4AffineTransform.hh"
 #include "G4VPhysicalVolume.hh"
@@ -51,4 +52,6 @@
 
 #include "G4BlockingList.hh"
+
+class G4VoxelSafety; 
 
 // Required for inline implementation
@@ -98,5 +101,5 @@
 
     inline G4int GetVerboseLevel() const;
-    inline void  SetVerboseLevel(G4int level);
+    void  SetVerboseLevel(G4int level);
       // Get/Set Verbose(ness) level.
       // [if level>0 && G4VERBOSE, printout can occur]
@@ -107,4 +110,7 @@
       // Is effective only with G4VERBOSE set.
 
+    inline void  EnableBestSafety( G4bool flag= false );
+      // Enable best-possible evaluation of isotropic safety
+
   protected:
 
@@ -113,4 +119,33 @@
                             const G4ThreeVector& localDirection,
                             const G4double currentStep );
+
+    G4SmartVoxelNode* VoxelLocateLight( G4SmartVoxelHeader* pHead,
+					const G4ThreeVector& localPoint ) const;
+
+  private:  // Logging functions
+
+    void PreComputeStepLog  (const G4VPhysicalVolume* motherPhysical,
+                                   G4double motherSafety,
+                             const G4ThreeVector& localPoint);
+    void AlongComputeStepLog(const G4VSolid* sampleSolid,
+                             const G4ThreeVector& samplePoint,
+                             const G4ThreeVector& sampleDirection,
+                             const G4ThreeVector& localDirection,
+                                   G4double sampleSafety,
+                                   G4double sampleStep);
+    void PostComputeStepLog (const G4VSolid* motherSolid,
+                             const G4ThreeVector& localPoint,
+                             const G4ThreeVector& localDirection,
+                                   G4double motherStep,
+                                   G4double motherSafety);
+    void ComputeSafetyLog   (const G4VSolid* solid,
+                             const G4ThreeVector& point,
+                                   G4double safety,
+                                   G4bool banner);
+    inline void PrintDaughterLog (const G4VSolid* sampleSolid,
+                                  const G4ThreeVector& samplePoint,
+                                        G4double sampleSafety,
+                                        G4double sampleStep);   
+  protected:
 
     G4BlockingList fBList;
@@ -147,7 +182,12 @@
     //
 
+    G4VoxelSafety  *fpVoxelSafety;
+    //  Helper object for Voxel Safety
+
     G4bool fCheck;
-    G4int  fVerbose;
-    G4double kCarTolerance;
+    G4bool fBestSafety; 
+
+    G4NavigationLogger* fLogger;
+      // Verbosity logger
 };
 
Index: trunk/source/geometry/navigation/include/G4VoxelNavigation.icc
===================================================================
--- trunk/source/geometry/navigation/include/G4VoxelNavigation.icc	(revision 1337)
+++ trunk/source/geometry/navigation/include/G4VoxelNavigation.icc	(revision 1347)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4VoxelNavigation.icc,v 1.4 2006/06/29 18:36:30 gunter Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// $Id: G4VoxelNavigation.icc,v 1.7 2010/11/04 17:38:17 japost Exp $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // 
@@ -67,7 +67,7 @@
     }
     else if ( targetNodeNo>=targetHeaderNoSlices )
-         {
-           targetNodeNo = targetHeaderNoSlices-1;
-         }
+    {
+      targetNodeNo = targetHeaderNoSlices-1;
+    }
     // Stack info for stepping
     //
@@ -169,15 +169,5 @@
 G4int G4VoxelNavigation::GetVerboseLevel() const
 {
-  return fVerbose;
-}
-
-// ********************************************************************
-// SetVerboseLevel
-// ********************************************************************
-//
-inline
-void  G4VoxelNavigation::SetVerboseLevel(G4int level)
-{
-  fVerbose = level;
+  return fLogger->GetVerboseLevel();
 }
 
@@ -191,2 +181,12 @@
   fCheck = mode;
 }
+
+// ********************************************************************
+// EnableBestSafety
+// ********************************************************************
+//
+inline
+void  G4VoxelNavigation::EnableBestSafety(G4bool flag)
+{
+  fBestSafety = flag;
+}
Index: trunk/source/geometry/navigation/src/G4AuxiliaryNavServices.cc
===================================================================
--- trunk/source/geometry/navigation/src/G4AuxiliaryNavServices.cc	(revision 1337)
+++ trunk/source/geometry/navigation/src/G4AuxiliaryNavServices.cc	(revision 1347)
@@ -25,5 +25,5 @@
 //
 // $Id: G4AuxiliaryNavServices.cc,v 1.3 2006/06/29 18:36:32 gunter Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // --------------------------------------------------------------------
Index: trunk/source/geometry/navigation/src/G4BrentLocator.cc
===================================================================
--- trunk/source/geometry/navigation/src/G4BrentLocator.cc	(revision 1337)
+++ trunk/source/geometry/navigation/src/G4BrentLocator.cc	(revision 1347)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4BrentLocator.cc,v 1.8 2009/05/15 12:55:48 tnikitin Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// $Id: G4BrentLocator.cc,v 1.9 2010/07/13 15:59:42 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // Class G4BrentLocator implementation
@@ -142,4 +142,5 @@
   G4bool restoredFullEndpoint = false;
 
+  G4int oldprc;  // cout, cerr precision
   G4int substep_no = 0;
    
@@ -505,5 +506,5 @@
                    << GetEpsilonStepFor() << G4endl;
           }
-          G4cerr.precision(20);
+          oldprc = G4cerr.precision(20);
           G4cerr << " Point A (Curve start)     is " << CurveStartPointVelocity
                  << G4endl;
@@ -529,4 +530,5 @@
                  << GetEpsilonStepFor() <<" DeltaInters= "
                  << GetDeltaIntersectionFor() << G4endl;
+          G4cerr.precision( oldprc ); 
 
           G4Exception("G4BrentLocator::EstimateIntersectionPoint()",
@@ -728,5 +730,5 @@
                  -1.0, NewSafety, substep_no);
     G4cout << G4endl;
-    G4cout.precision( 10 ); 
+    oldprc = G4cout.precision( 10 ); 
     G4double done_len = CurrentA_PointVelocity.GetCurveLength(); 
     G4double full_len = CurveEndPointVelocity.GetCurveLength();
@@ -736,4 +738,5 @@
            << " out of " << full_len << " required." << G4endl;
     G4cout << "        Remaining length = " << full_len - done_len << G4endl; 
+    G4cout.precision( oldprc ); 
 
     G4Exception("G4BrentLocator::EstimateIntersectionPoint()",
@@ -743,5 +746,5 @@
   else if( substep_no >= warn_substeps )
   {  
-    G4int oldprc= G4cout.precision( 10 ); 
+    oldprc= G4cout.precision( 10 ); 
     G4cout << "WARNING - G4BrentLocator::EstimateIntersectionPoint()"
            << G4endl
Index: trunk/source/geometry/navigation/src/G4DrawVoxels.cc
===================================================================
--- trunk/source/geometry/navigation/src/G4DrawVoxels.cc	(revision 1337)
+++ trunk/source/geometry/navigation/src/G4DrawVoxels.cc	(revision 1347)
@@ -26,5 +26,5 @@
 //
 // $Id: G4DrawVoxels.cc,v 1.4 2006/06/29 18:36:34 gunter Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // 
Index: trunk/source/geometry/navigation/src/G4ErrorPropagationNavigator.cc
===================================================================
--- trunk/source/geometry/navigation/src/G4ErrorPropagationNavigator.cc	(revision 1337)
+++ trunk/source/geometry/navigation/src/G4ErrorPropagationNavigator.cc	(revision 1347)
@@ -26,5 +26,5 @@
 //
 // $Id: G4ErrorPropagationNavigator.cc,v 1.2 2008/10/24 14:00:03 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 //
Index: trunk/source/geometry/navigation/src/G4GeomTestErrorList.cc
===================================================================
--- trunk/source/geometry/navigation/src/G4GeomTestErrorList.cc	(revision 1337)
+++ trunk/source/geometry/navigation/src/G4GeomTestErrorList.cc	(revision 1347)
@@ -26,5 +26,5 @@
 //
 // $Id: G4GeomTestErrorList.cc,v 1.3 2006/06/29 18:36:36 gunter Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // --------------------------------------------------------------------
Index: trunk/source/geometry/navigation/src/G4GeomTestOverlapList.cc
===================================================================
--- trunk/source/geometry/navigation/src/G4GeomTestOverlapList.cc	(revision 1337)
+++ trunk/source/geometry/navigation/src/G4GeomTestOverlapList.cc	(revision 1347)
@@ -26,5 +26,5 @@
 //
 // $Id: G4GeomTestOverlapList.cc,v 1.3 2006/06/29 18:36:39 gunter Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // --------------------------------------------------------------------
Index: trunk/source/geometry/navigation/src/G4GeomTestOvershootList.cc
===================================================================
--- trunk/source/geometry/navigation/src/G4GeomTestOvershootList.cc	(revision 1337)
+++ trunk/source/geometry/navigation/src/G4GeomTestOvershootList.cc	(revision 1347)
@@ -26,5 +26,5 @@
 //
 // $Id: G4GeomTestOvershootList.cc,v 1.3 2006/06/29 18:36:41 gunter Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // --------------------------------------------------------------------
Index: trunk/source/geometry/navigation/src/G4GeomTestPoint.cc
===================================================================
--- trunk/source/geometry/navigation/src/G4GeomTestPoint.cc	(revision 1337)
+++ trunk/source/geometry/navigation/src/G4GeomTestPoint.cc	(revision 1347)
@@ -26,5 +26,5 @@
 //
 // $Id: G4GeomTestPoint.cc,v 1.3 2006/06/29 18:36:44 gunter Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // --------------------------------------------------------------------
Index: trunk/source/geometry/navigation/src/G4GeomTestSegment.cc
===================================================================
--- trunk/source/geometry/navigation/src/G4GeomTestSegment.cc	(revision 1337)
+++ trunk/source/geometry/navigation/src/G4GeomTestSegment.cc	(revision 1347)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4GeomTestSegment.cc,v 1.11 2007/11/16 09:39:14 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// $Id: G4GeomTestSegment.cc,v 1.13 2010/08/20 09:03:54 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // --------------------------------------------------------------------
@@ -275,6 +275,5 @@
   G4bool entering;
   G4double vSurfN;
-  // G4cout<<"Entering Find Some Points vSearch="<<vSearch<<" p="<<p<<G4endl;
-  //
+ 
   // Look for nearest intersection point in the specified
   // direction and return if there isn't one
@@ -283,6 +282,5 @@
   switch(solid->Inside(p)) {
     case kInside:
-       dist = solid->DistanceToOut(p,vSearch);
-       // G4cout<<"Inside DistToOut="<<dist<<G4endl;
+      dist = solid->DistanceToOut(p,vSearch);
       if (dist >= kInfinity) {
         logger->SolidProblem( solid,
@@ -290,5 +288,4 @@
         return;
       }
-      
       s += sign*dist;
       entering = false;
@@ -296,15 +293,12 @@
     case kOutside:
       dist = solid->DistanceToIn(p,vSearch);
-      //G4cout<<"Outside DistToIn="<<dist<<G4endl;
       if (dist >= kInfinity) return;
-      
       s += sign*dist;
       entering = true;
       break;
     case kSurface:
-      vSurfN=vSearch.dot(solid->SurfaceNormal(p));
-      if(std::abs(vSurfN)<kCarTolerance)vSurfN=0;
+      vSurfN=v.dot(solid->SurfaceNormal(p));
+      if(std::fabs(vSurfN)<kCarTolerance)vSurfN=0;
       entering = (vSurfN < 0);
-      //G4cout<<"Surface SurfN="<<solid->SurfaceNormal(p)<<" v.dotN="<<vSurfN<<" entering="<<entering<<G4endl;
       break;
     default:
@@ -361,5 +355,5 @@
       //
       points.push_back( G4GeomTestPoint( p, s, entering==forward ) );
-      //G4cout<<"Add point p"<<p<<" s="<<s<<" entering="<<entering<<G4endl;
+      
     }
     
@@ -369,5 +363,4 @@
     if (entering) {
       dist = solid->DistanceToOut(p,vSearch);
-      //G4cout<<"if entering distToOut="<<dist<<G4endl;
       if (dist >= kInfinity) {
         logger->SolidProblem( solid,
@@ -389,22 +382,9 @@
         return;
       }
-
-       if(std::abs(dist)<=kCarTolerance){
-          G4double push = 1E-6;
-          s += sign*push;
-          p = p0 + s*v;
-          EInside inside = solid->Inside(p); 
-          if (inside == kOutside) {
-          entering = false;
-          break;
-        }
-      }
-
-      
+            
       entering = false;
     }
     else {
       dist = solid->DistanceToIn(p,vSearch);
-      //G4cout<<"if exiting distToIn="<<dist<<G4endl;
       if (dist >= kInfinity) return;
       
Index: trunk/source/geometry/navigation/src/G4GeomTestStreamLogger.cc
===================================================================
--- trunk/source/geometry/navigation/src/G4GeomTestStreamLogger.cc	(revision 1337)
+++ trunk/source/geometry/navigation/src/G4GeomTestStreamLogger.cc	(revision 1347)
@@ -26,5 +26,5 @@
 //
 // $Id: G4GeomTestStreamLogger.cc,v 1.3 2006/06/29 18:36:49 gunter Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // --------------------------------------------------------------------
Index: trunk/source/geometry/navigation/src/G4GeomTestVolPoint.cc
===================================================================
--- trunk/source/geometry/navigation/src/G4GeomTestVolPoint.cc	(revision 1337)
+++ trunk/source/geometry/navigation/src/G4GeomTestVolPoint.cc	(revision 1347)
@@ -26,5 +26,5 @@
 //
 // $Id: G4GeomTestVolPoint.cc,v 1.3 2006/06/29 18:36:52 gunter Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // --------------------------------------------------------------------
Index: trunk/source/geometry/navigation/src/G4GeomTestVolume.cc
===================================================================
--- trunk/source/geometry/navigation/src/G4GeomTestVolume.cc	(revision 1337)
+++ trunk/source/geometry/navigation/src/G4GeomTestVolume.cc	(revision 1347)
@@ -26,5 +26,5 @@
 //
 // $Id: G4GeomTestVolume.cc,v 1.6 2007/11/16 09:39:14 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // --------------------------------------------------------------------
Index: trunk/source/geometry/navigation/src/G4GeometryMessenger.cc
===================================================================
--- trunk/source/geometry/navigation/src/G4GeometryMessenger.cc	(revision 1337)
+++ trunk/source/geometry/navigation/src/G4GeometryMessenger.cc	(revision 1347)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4GeometryMessenger.cc,v 1.5 2006/06/29 18:36:57 gunter Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// $Id: G4GeometryMessenger.cc,v 1.6 2010/11/10 14:06:40 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // --------------------------------------------------------------------
@@ -106,4 +106,16 @@
   chkCmd->AvailableForStates(G4State_Idle);
 
+  pchkCmd = new G4UIcmdWithABool( "/geometry/navigator/push_notify", this );
+  pchkCmd->SetGuidance( "Set navigator verbosity push notifications." );
+  pchkCmd->SetGuidance( "This allows to disable/re-enable verbosity in" );
+  pchkCmd->SetGuidance( "navigation, when tracks may get stuck and require" );
+  pchkCmd->SetGuidance( "one artificial push along the direction by the" );
+  pchkCmd->SetGuidance( "navigator. Notification is active by default." );
+  pchkCmd->SetGuidance( "NOTE: this command has effect -only- if Geant4 has" );
+  pchkCmd->SetGuidance( "      been installed with the G4VERBOSE flag set!" );
+  pchkCmd->SetParameterName("pushFlag",true);
+  pchkCmd->SetDefaultValue(true);
+  pchkCmd->AvailableForStates(G4State_Idle);
+
   //
   // Geometry verification test commands
@@ -244,5 +256,5 @@
   delete cyzCmd; delete cfzCmd; delete cfrCmd; delete cylCmd;
   delete tolCmd;
-  delete resCmd; delete verbCmd; delete chkCmd;
+  delete resCmd; delete verbCmd; delete pchkCmd; delete chkCmd;
   delete geodir; delete navdir; delete testdir;
   delete tvolume; delete tlogger;
@@ -423,4 +435,15 @@
   G4Navigator* navigator = tmanager->GetNavigatorForTracking();
   navigator->CheckMode(mode);
+}
+
+//
+// Set navigator verbosity for push notifications
+//
+void
+G4GeometryMessenger::SetPushFlag(G4String input)
+{
+  G4bool mode = pchkCmd->GetNewBoolValue(input);
+  G4Navigator* navigator = tmanager->GetNavigatorForTracking();
+  navigator->SetPushVerbosity(mode);
 }
 
Index: trunk/source/geometry/navigation/src/G4MultiLevelLocator.cc
===================================================================
--- trunk/source/geometry/navigation/src/G4MultiLevelLocator.cc	(revision 1337)
+++ trunk/source/geometry/navigation/src/G4MultiLevelLocator.cc	(revision 1347)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4MultiLevelLocator.cc,v 1.5 2008/12/11 10:01:02 tnikitin Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// $Id: G4MultiLevelLocator.cc,v 1.6 2010/07/13 15:59:42 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-04-ref-00 $
 //
 // Class G4MultiLevelLocator implementation
@@ -120,5 +120,7 @@
 
   G4int substep_no = 0;
-   
+
+  G4int oldprc;   // cout/cerr precision settings
+
   // Limits for substep number
   //
@@ -156,7 +158,7 @@
 
 #ifdef G4DEBUG_FIELD
-  static G4double tolerance= 1.0e-8; 
+  static const G4double tolerance = 1.0e-8 * mm; 
   G4ThreeVector  StartPosition= CurveStartPointVelocity.GetPosition(); 
-  if( (TrialPoint - StartPosition).mag() < tolerance * mm ) 
+  if( (TrialPoint - StartPosition).mag() < tolerance) 
   {
      G4cerr << "WARNING - G4MultiLevelLocator::EstimateIntersectionPoint()"
@@ -455,5 +457,5 @@
                    << GetEpsilonStepFor() << G4endl;
           }
-          G4cerr.precision(20);
+          oldprc = G4cerr.precision(20);
           G4cerr << " Point A (Curve start)   is " << CurveStartPointVelocity
                  << G4endl;
@@ -474,4 +476,5 @@
           G4cerr << "        Substep depth no= "<< substep_no_p  << " Depth= "
                  << depth << G4endl;
+          G4cerr.precision(oldprc);
 
           G4Exception("G4MultiLevelLocator::EstimateIntersectionPoint()",
@@ -691,5 +694,5 @@
 #endif
 
-    G4cout.precision( 10 ); 
+    oldprc = G4cout.precision( 10 ); 
     G4double done_len = CurrentA_PointVelocity.GetCurveLength(); 
     G4double full_len = CurveEndPointVelocity.GetCurveLength();
@@ -699,4 +702,5 @@
            << " out of " << full_len << " required." << G4endl;
     G4cout << "        Remaining length = " << full_len - done_len << G4endl; 
+    G4cout.precision( oldprc ); 
 
     G4Exception("G4MultiLevelLocator::EstimateIntersectionPoint()",
@@ -706,5 +710,5 @@
   else if( substep_no >= warn_substeps )
   {  
-    G4int oldprc= G4cout.precision( 10 ); 
+    oldprc = G4cout.precision( 10 ); 
     G4cout << "WARNING - G4MultiLevelLocator::EstimateIntersectionPoint()"
            << G4endl
Index: trunk/source/geometry/navigation/src/G4MultiNavigator.cc
===================================================================
--- trunk/source/geometry/navigation/src/G4MultiNavigator.cc	(revision 1337)
+++ trunk/source/geometry/navigation/src/G4MultiNavigator.cc	(revision 1347)
@@ -25,5 +25,5 @@
 //
 //
-// $Id: G4MultiNavigator.cc,v 1.8 2008/10/24 14:00:03 gcosmo Exp $
+// $Id: G4MultiNavigator.cc,v 1.11 2010/09/06 09:49:15 gcosmo Exp $
 // GEANT4 tag $ Name:  $
 // 
@@ -48,8 +48,8 @@
 //
 G4MultiNavigator::G4MultiNavigator() 
-  : G4Navigator()
+  : G4Navigator(), fLastMassWorld(0)
 {
   fNoActiveNavigators= 0; 
-  G4ThreeVector Big3Vector( DBL_MAX, DBL_MAX, DBL_MAX ); 
+  G4ThreeVector Big3Vector( kInfinity, kInfinity, kInfinity ); 
   fLastLocatedPosition = Big3Vector;
   fSafetyLocation  = Big3Vector;
@@ -58,13 +58,13 @@
   fMinSafety_PreStepPt=  -1.0; 
   fMinSafety_atSafLocation= -1.0; 
-  fMinSafety= -DBL_MAX;  
-  fMinStep=   -DBL_MAX;  
-
-  for(register int num=0; num<= fMaxNav; ++num )
+  fMinSafety= -kInfinity;  
+  fTrueMinStep= fMinStep= -kInfinity;  
+
+  for(register int num=0; num< fMaxNav; ++num )
   {
     fpNavigator[num] =  0;   
     fLimitTruth[num] = false;
     fLimitedStep[num] = kUndefLimited;
-    fCurrentStepSize[num] = -1.0; 
+    fCurrentStepSize[num] = fNewSafety[num] = -1.0; 
     fLocatedVolume[num] = 0; 
   }
@@ -94,5 +94,5 @@
 {
   G4double safety= 0.0, step=0.0;
-  G4double minSafety= DBL_MAX, minStep= DBL_MAX;
+  G4double minSafety= kInfinity, minStep= kInfinity;
 
 #ifdef G4DEBUG_NAVIGATION
@@ -115,5 +115,5 @@
   for( register int num=0; num< fNoActiveNavigators; ++pNavigatorIter,++num )
   {
-     safety= DBL_MAX;
+     safety= kInfinity;
 
      step= (*pNavigatorIter)->ComputeStep( initialPosition, 
@@ -189,11 +189,5 @@
                                    ELimited &limitedStep) 
 {
-  G4int navigatorNo=-1; 
-
-  if( navigatorId <= fNoActiveNavigators )
-  {
-     navigatorNo= navigatorId;
-  }
-  else
+  if( navigatorId > fNoActiveNavigators )
   { 
      G4cerr << "ERROR - G4MultiNavigator::ObtainFinalStep()"
@@ -206,18 +200,21 @@
 
   // Prepare the information to return
-  pNewSafety  = fNewSafety[ navigatorNo ]; 
-  limitedStep = fLimitedStep[ navigatorNo ];
+  //
+  pNewSafety  = fNewSafety[ navigatorId ]; 
+  limitedStep = fLimitedStep[ navigatorId ];
   minStep= fMinStep; 
 
-  // if( (minStep==kInfinity) || (fVerbose > 1) ){ 
-#ifdef G4DEBUG_NAVIGATION
-  if( fVerbose > 1 ){ 
-     G4cout << " G4MultiNavigator::ComputeStep returns " << fCurrentStepSize[ navigatorNo ]
-            << " for Navigator " << navigatorNo << " Limited step = " << limitedStep 
+#ifdef G4DEBUG_NAVIGATION
+  if( fVerbose > 1 )
+  { 
+     G4cout << " G4MultiNavigator::ComputeStep returns "
+            << fCurrentStepSize[ navigatorId ]
+            << " for Navigator " << navigatorId
+            << " Limited step = " << limitedStep 
             << " Safety(mm) = " << pNewSafety / mm << G4endl; 
   }
 #endif
 
-  return fCurrentStepSize[ navigatorNo ];
+  return fCurrentStepSize[ navigatorId ];
 }
 
@@ -428,5 +425,5 @@
     // Recompute safety for the relevant point
 
-    G4double minSafety = DBL_MAX, safety = DBL_MAX;
+    G4double minSafety = kInfinity, safety = kInfinity;
   
     std::vector<G4Navigator*>::iterator pNavigatorIter;
